function [F1,F2,H,dH,h,dir] = vectorfields(t,y,params,str)

%Parameters
z      = params(1);
w      = params(2);
s      = params(3);
l=params(4);

%Vector field in region 1 - H(x) > 0
F1 = [-(2*z*w+l)*y(1)+y(2)-1;...
      -(2*z*w*l+w*w)*y(1)+y(3)-2*s;...
      -l*w*w*y(1)-1];

%Vector field in region 2 - H(x) < 0
F2 = [-(2*z*w+l)*y(1)+y(2)+1;...
      -(2*z*w*l+w*w)*y(1)+y(3)+2*s;...
      -l*w*w*y(1)+1];
%Switching Manifold
H = y(1);

%A vector normal to the switching manifold
dH = [1,0,0];

%Poincare section
h = 1;

%Location directrion
dir = 1;
