function [tvect,yvect,te,ye,ie,se] = filippov2s(vfields,jacobians,pfunction,solver,tspan,y0,params,C,inopts)
% Version 2005-06-27

% Time
t0 = tspan(1);
t1 = tspan(end);

tspan = [t0,t1];

%State initialisation
[state dir] = findstate(vfields,jacobians,t0,y0,params);

options = odeset(inopts,'Events',@fevents);

yvect = [];tvect = [];
te = []; ye = []; ie = []; se = [];
stopit = 0;

while ~stopit
    [t,y,TE,YE,IE] = feval(solver,@filippovfunc,tspan,y0,options,vfields,jacobians,params,C,state,dir);
  
    y0 = y(end,:);
    yvect = [yvect;y];
    tvect = [tvect;t];
    te = [te;TE];
    ye = [ye;YE];

    tspan =[t(end),t1];
    
    if ~isempty(IE) & (t(end)~=t1)
        for k = 1:length(IE)
            ie = [ie;IE(k)];
            for n = 1:2
                if IE(k) == (n-1)*5+4
                    if ~isempty(pfunction)
                        y0 = feval(pfunction,t(end),y0,params,n);                
                    end
                else
                    switch 1
                        case state((n-1)*5+3)
                            switch IE(k)
                                case {(n-1)*5+2}
                                    state(IE(k)-1) = -state(IE(k)-1);
                                    state((n-1)*5+3) = -state((n-1)*5+3);
                                    state((n-1)*5+4) = -state((n-1)*5+4);
                                    state((n-1)*5+5) = -state((n-1)*5+5);
                                    state(10+n) = 1;
                                    dir(n,[1,-(n-1)*5+IE(k)]) = [-(IE(k) == (n-1)*5+2)+(IE(k) == (n-1)*5+3),-dir(n,-(n-1)*5+IE(k))];
                                case {3,7}
                                    p =  ispara(vfields,t(end),y0,params);
                                    if n==1 | ~p
                                        state(IE(k)-1) = -state(IE(k)-1);
                                        state((n-1)*5+3) = -state((n-1)*5+3);
                                        state((n-1)*5+4) = -state((n-1)*5+4);
                                        state((n-1)*5+5) = -state((n-1)*5+5);
                                        state(10+n) = 1;
                                        dir(n,[1,-(n-1)*5+IE(k)]) = [-(IE(k) == (n-1)*5+2)+(IE(k) == (n-1)*5+3),-dir(n,-(n-1)*5+IE(k))];
                                        if n == 1 & p
                                            state(9) = -state(9);
                                            state(10) = -state(10);
                                        end
                                    else
                                        state(6) = -state(6);
                                        state((n-1)*5+3) = -state((n-1)*5+3);
                                        state(10+n) = 1;
                                        dir(n,[1,-(n-1)*5+7]) = [-(7 == (n-1)*5+2)+(7 == (n-1)*5+3),-dir(n,-(n-1)*5+7)];                                    
                                    end
                                  
                                case (n-1)*5+5,
                                    
                                case {(2-n)*5+2,(2-n)*5+3,(2-n)*5+5},
                                    
                                otherwise
                                    disp('Error, there is something wrong with the event in filippov 3')
                            end
                        case state((n-1)*5+4)
                            switch IE(k)
                                case (n-1)*5+1,
                                   state((n-1)*5+1)=-state((n-1)*5+1);
                                   state((n-1)*5+2)=-state((n-1)*5+2);
                                   state(10+n) = 1;                                   
                                   dir(n,-(n-1)*5+IE(k)) = -dir(n,-(n-1)*5+IE(k));
                                case {(n-1)*5+2}
                                    state((n-1)*5+4) = -state((n-1)*5+4);
                                    state((n-1)*5+5) = -state((n-1)*5+5);
                                    state(10+n) = -1;
                                    dir(n,-(n-1)*5+IE(k)) = -dir(n,-(n-1)*5+IE(k));
                                case {(n-1)*5+3}
                                    p =  ispara(vfields,t(end),y0,params);
                                    state((n-1)*5+4) = -state((n-1)*5+4);
                                    state((n-1)*5+5) = -state((n-1)*5+5);
                                    state(10+n) = -1;
                                    dir(n,-(n-1)*5+IE(k)) = -dir(n,-(n-1)*5+IE(k));
                                    if n == 1 & p
                                        state(9) = -state(9);
                                        state(10) = -state(10);
                                        state(12) = -1;
                                    end
                                case (n-1)*5+5,
                                case {(2-n)*5+1,(2-n)*5+2,(2-n)*5+3,(2-n)*5+5},                            
                                otherwise
                                    disp('Error, there is something wrong with the event in filippov 4')
                            end
                        case state((n-1)*5+5)
                            switch IE(k)
                                case (n-1)*5+1,
                                   state((n-1)*5+1)=-1;
                                   state((n-1)*5+2)=-1;
                                   state((n-1)*5+3)=-state((n-1)*5+3);
                                   state(13-n) = -1;
                                   dir(n,-(n-1)*5+IE(k)) = -dir(n,-(n-1)*5+IE(k));
                                case {(n-1)*5+2}
                                    state((n-1)*5+4) = -state((n-1)*5+4);
                                    state((n-1)*5+5) = -state((n-1)*5+5);    
                                    dir(n,-(n-1)*5+IE(k)) = -dir(n,-(n-1)*5+IE(k));
                                case {(n-1)*5+3}
                                    p =  ispara(vfields,t(end),y0,params);
                                    state((n-1)*5+4) = -state((n-1)*5+4);
                                    state((n-1)*5+5) = -state((n-1)*5+5);    
                                    dir(n,-(n-1)*5+IE(k)) = -dir(n,-(n-1)*5+IE(k));
                                    if n == 1 & p
                                        state(9) = -state(9);
                                        state(10) = -state(10);
                                    end
                               case (n-1)*5+5,
                                case {(2-n)*5+1,(2-n)*5+2,(2-n)*5+3,(2-n)*5+5},                                                            
                                otherwise
                                    disp('Error, there is something wrong with the event in filippov 5')
                            end
                        otherwise
                            disp('Other state')
                            %disp('Error, There is something wrong with the state vector in filippov')        
                    end
                end
                se = [se;state];                                    
            end
        end
    elseif ~isempty(IE)
        stopit =1;
        ie = [ie;IE];
        se = [se;state];
    else
        stopit =1;    
    end
end

%-------------------- findstate ------------------------

function [state,dir] = findstate(vfields,jacobians,t0,y0,params);

state = -1*ones(1,12);

[F,H,dH,h1,hdir] = feval(vfields,t0,y0,params,'');

mu = zeros(1,2);
temp = [];

for k = 1:2
    if H(k) > 0    
        state((k-1)*5+1) = -state((k-1)*5+1);
        mu(k) = 0;
    elseif H(k) < 0
        state((k-1)*5+2) = -state((k-1)*5+2);
        mu(k) = 1;
    else
        temp = [temp k];
    end
end
    
if ~isempty(temp)
    switch sum(temp)
        case 1
            mu(1) = -(dH(1,:)*(F(:,1) + F(:,3)*mu(2)))/(dH(1,:)*F(:,2));
            mu(1) = min(1,max(0,mu(1)));
        case 2
            mu(2) = -(dH(2,:)*(F(:,1) + F(:,2)*mu(1)))/(dH(2,:)*F(:,3));
            mu(2) = min(1,max(0,mu(2)));
        case 3
            mu12 = -inv([dH(1,:)*F(:,2) dH(1,:)*F(:,3);dH(2,:)*F(:,2) dH(2,:)*F(:,3)])*[dH(1,:)*F(:,1);dH(2,:)*F(:,1)];
            mu = [min(1,max(0,mu12(1))) min(1,max(0,mu12(2)))];
        otherwise
    end
    
    for k = 1:2
        if  mu(k) > 0 & mu(k) < 1
            state((k-1)*5+3) = -state((k-1)*5+3);
        else        
            dHF1 = dH(k,:)*(F(:,1)+F(:,4-k)*mu(k));
            if sign(dHF1) > 0
                state((k-1)*5+1) = -state((k-1)*5+1);
            else
                state((k-1)*5+2) = -state((k-1)*5+2);
            end        
        end
    end
end

F1 = F(:,1)+F(:,3)*mu(2);
F2 = F(:,1)+F(:,2)+F(:,3)*mu(2);
dHF1 = dH(1,:)*F1;
dHF2 = dH(1,:)*F2;
dir1 = [-sign(H(1)),-sign(dHF1),-sign(dHF2)];
        
if sign(dHF1)*sign(dHF2) > 0
    state(4) = -state(4);
elseif sign(dHF1)*sign(dHF2) < 0
    state(5) = -state(5);    
else
    if isempty(jacobians)
        state(4) = -state(4);
    else
        [Jtot,d2H] = feval(jacobians,t0,y0,params,'');
        
        nsys = lengths(:,1);
        J = Jtot(1:nsys,1:nsys);
        D1 = Jtot(1:nsys,nsys+1:2*nsys);
        D2 = Jtot(1:nsys,2*nsys+1:3*nsys);
                
        if dHF1 == 0 & dHF2 == 0
                J1 = J + D2*mu(2);
                J2 = J + D1*mu(1) + D2*mu(2);
                HxF1x_F1Hxx = dH(1,:)*J1 + F1'*d2H(1:nsys,1:nsys);
                HxF2x_F2Hxx = dH(1,:)*J2 + F2'*d2H(1:nsys,1:nsys);
                sig = sign(HxF1x_F1Hxx*F1)*sign(HxF2x_F2Hxx*F2);
        else
            if dHF1 == 0
                J1 = J + D2*mu(2);
                HxF1x_F1Hxx = dH(1,:)*J1 + F1'*d2H(1:nsys,1:nsys);
                sig = sign(HxF1x_F1Hxx*F1)*sign(dHF2);
                dir(2) = -sign(HxF1x_F1Hxx*F1);
            end
        
            if dHF2 == 0
                J2 = J + D1*mu(1) + D2*mu(2);
                HxF2x_F2Hxx = dH(1,:)*J2 + F2'*d2H(1:nsys,1:nsys);
                sig = sign(HxF2x_F2Hxx*F2)*sign(dHF1);
                dir(3) = -sign(HxF2x_F2Hxx*F2);
            end
        end
        
        if sig < 0
            state(5) = -state(5);
        else
            state(4) = -state(4);
        end
    end
end

F1 = F(:,1)+F(:,2)*mu(1);
F2 = F(:,1)+F(:,2)*mu(1)+F(:,3);
dHF1 = dH(2,:)*F1;
dHF2 = dH(2,:)*F2;
dir2 = [-sign(H(2)),-sign(dHF1),-sign(dHF2)];

if sign(dHF1)*sign(dHF2) > 0
    state(9) = -state(9);
elseif sign(dHF1)*sign(dHF2) < 0
    state(10) = -state(10);    
else
    if isempty(jacobians)
        state(9) = -state(9);
    else
        [Jtot,d2H] = feval(jacobians,t0,y0,params,'');
        
        nsys = lengths(:,1);
        J = Jtot(1:nsys,1:nsys);
        D1 = Jtot(1:nsys,nsys+1:2*nsys);
        D2 = Jtot(1:nsys,2*nsys+1:3*nsys);
                
        if dHF1 == 0 & dHF2 == 0
                J1 = J + D1*mu(1);
                J2 = J + D1*mu(1) + D2*mu(2);
                HxF1x_F1Hxx = dH(2,:)*J1 + F1'*d2H(1:nsys,nsys+1:2*nsys);
                HxF2x_F2Hxx = dH(2,:)*J2 + F2'*d2H(1:nsys,nsys+1:2*nsys);
                sig = sign(HxF1x_F1Hxx*F1)*sign(HxF2x_F2Hxx*F2);
        else
            if dHF1 == 0
                J1 = J + D1*mu(1);
                HxF1x_F1Hxx = dH(2,:)*J1 + F1'*d2H(1:nsys,nsys+1:2*nsys);
                sig = sign(HxF1x_F1Hxx*F1)*sign(dHF2);
                dir(2) = -sign(HxF1x_F1Hxx*F1);
            end
        
            if dHF2 == 0
                J2 = J + D1*mu(1) + D2*mu(2);
                HxF2x_F2Hxx = dH(2,:)*J2 + F2'*d2H(1:nsys,nsys+1:2*nsys);
                sig = sign(HxF2x_F2Hxx*F2)*sign(dHF1);
                dir(3) = -sign(HxF2x_F2Hxx*F2);
            end
        end
        
        if sig < 0
            state(10) = -state(10);
        else
            state(9) = -state(9);
        end
    end
end

dir = [dir1;dir2];

%-------------------    Find mu     ----------------------

function mu =  findmu(F,dH,state);

temp = [];
C = [0 0];

for k = 1:2
    switch 1
        case state(5*(k-1)+1)
            mu(k) = 0;    
        case state(5*(k-1)+2)
            mu(k) = 1;
        case state(5*(k-1)+3)
            temp = [temp k];
            C(k) = 1;
        otherwise
    end
end

if ~isempty(temp)
    switch sum(temp)
        case 1
            mu(1) = -(dH(1,:)*(F(:,1) + F(:,3)*mu(2)))/(dH(1,:)*F(:,2));
        case 2
            mu(2) = -(dH(2,:)*(F(:,1) + F(:,2)*mu(1)))/(dH(2,:)*F(:,3));
        case 3
            mu12 = -inv([dH(1,:)*F(:,2) dH(1,:)*F(:,3);dH(2,:)*F(:,2) dH(2,:)*F(:,3)])*[dH(1,:)*F(:,1);dH(2,:)*F(:,1)];
            mu = [mu12(1) mu12(2)];
        otherwise
    end
end

%-------------------    Check if parallel     ----------------------

function p =  ispara(vfields,t,y,params);

[F,H,dH,h1,hdir] = feval(vfields,t,y,params,'');

v1 = dH(1,:)/norm(dH(1,:));
v2 = dH(2,:)/norm(dH(2,:));

p = v1*v2';

%-------------------- filippovfunc ------------------------

function dy = filippovfunc(t,y,vfields,jacobians,params,C,state,dir);

dy=zeros(length(y),1);

[F,H,dH,h1,hdir] = feval(vfields,t,y,params,'');

mu = findmu(F,dH,state);

C = [C(1)*(state(3)==1),C(2)*(state(8)==1)];
dy = F(:,1) + F(:,2)*mu(1)+ F(:,3)*mu(2) - C(1)*dH(1,:)'*H(1) - C(2)*dH(2,:)'*H(2);

%-------------------- filippovevents ------------------------

function [value,isterminal,direction] = fevents(t,y,vfields,jacobians,params,C,state,dir)
%fevents(t,y,params,vfields,state);
                                       
[F,H,dH,h1,hdir] = feval(vfields,t,y,params,'');
mu = findmu(F,dH,state);
p =  ispara(vfields,t,y,params);

% First surface
if state(3)==1 | state(11)==1
    H(1) = 1;
end

if p
    F1 = F(:,1);
    F2 = F(:,1) + F(:,2);    
else
    F1 = F(:,1) + F(:,3)*mu(2);
    F2 = F(:,1) + F(:,2) + F(:,3)*mu(2);
end


value1 = [H(1),dH(1,:)*F1,dH(1,:)*F2,h1(1),1];
direction1 = [dir(1,:),hdir(1),1];
isterminal1 = [1,1,1,1,0];


% Second surface
if state(8)==1 | state(12)==1 
    H(2) = 1;
end

if p
    F1 = F(:,1) + F(:,2);
    F2 = F(:,1) + F(:,2)+ F(:,3);
    value2 = [H(2),1,dH(2,:)*F2,h1(2),1];
else
    F1 = F(:,1) + F(:,2)*mu(1);
    F2 = F(:,1) + F(:,2)*mu(1)+ F(:,3);    
    value2 = [H(2),dH(2,:)*F1,dH(2,:)*F2,h1(2),1];
end

direction2 = [dir(2,:),hdir(2),1]; % FIX!
isterminal2 = [1,1,1,1,0];


% Merge surfaces
value      = [value1, value2];
direction  = [direction1, direction2];
isterminal = [isterminal1, isterminal2];
